!= Module StoreDensCloud
!
! Authors::   SUGIYAMA Ko-ichiro
! Version::   $Id: storedenscloud_2d-2.f90,v 1.1 2011-02-23 17:20:13 yamasita Exp $ 
! Tag Name::  $Name: arare4-20110318 $
! Copyright:: Copyright (C) GFD Dennou Club, 2006. All rights reserved.
! License::   See COPYRIGHT[link:../../COPYRIGHT]
!
!== Overview 
!
! * ̩٤˴ؤѻͤݴɤ뤿ѿ⥸塼(ʬŷ׻). 
! * tendency  x,z,t δؿ
! * write ʸǳƻǤ tendency 񤭽Ф
!
!== Error Handling
!
!== Known Bugs
!
!== Note
!
!== Future Plans
!

module StoreDensCloud
  !
  !̩٤˴ؤѻͤݴɤ뤿ѿ⥸塼.
  !

  !⥸塼ɤ߹
  use gridset, only:   DimXMin,     & ! x β
    &                  DimXMax,     & ! x ξ
    &                  DimZMin,     & ! z β
    &                  DimZMax,     & ! z ξ
    &                  SpcNum,      & ! number of species
    &                  RegXMin,     & ! x ʪΰβ
    &                  RegXMax        ! x ʪΰξ
  use TimeSet, only:   TimeDisp,    & ! ϻֳִ
    &                  DelTimeShort   ! û֥ƥå

  !ۤηػ
  implicit none

  !°λ
  private

  !
  public StoreDensCloud_Init, StoreDensCloudMean, StoreDensCloudClean
  public xz_DensCloudAdv, xz_DensCloudTurb, xz_DensCloudDiff, &
    &    xz_DensCloudCond, xz_DensCloudFill
  public StoreDensCloudAdv,  StoreDensCloudTurb, StoreDensCloudDiff, &
    &    StoreDensCloudCond, StoreDensCloudFill

  !ѿ
  real(8), allocatable :: z_DensCloudAdv(:)
  real(8), allocatable :: z_DensCloudTurb(:)
  real(8), allocatable :: z_DensCloudDiff(:)
  real(8), allocatable :: z_DensCloudCond(:)
  real(8), allocatable :: z_DensCloudFill(:)
  real(8), allocatable :: xz_DensCloudAdv(:,:)
  real(8), allocatable :: xz_DensCloudTurb(:,:)
  real(8), allocatable :: xz_DensCloudDiff(:,:)
  real(8), allocatable :: xz_DensCloudCond(:,:)
  real(8), allocatable :: xz_DensCloudFill(:,:)

  !save °
  save xz_DensCloudAdv, xz_DensCloudTurb, xz_DensCloudDiff, xz_DensCloudCond, xz_DensCloudFill
  save z_DensCloudAdv, z_DensCloudTurb, z_DensCloudDiff, z_DensCloudCond, z_DensCloudFill

contains

  subroutine StoreDensCloud_Init( )
    !롼

    allocate(     &
      & z_DensCloudAdv(DimZMin:DimZMax),  & 
      & z_DensCloudTurb(DimZMin:DimZMax), &
      & z_DensCloudDiff(DimZMin:DimZMax), &
      & z_DensCloudCond(DimZMin:DimZMax), &
      & z_DensCloudFill(DimZMin:DimZMax), &
      & xz_DensCloudAdv(DimXMin:DimXMax, DimZMin:DimZMax),  & 
      & xz_DensCloudTurb(DimXMin:DimXMax, DimZMin:DimZMax), &
      & xz_DensCloudDiff(DimXMin:DimXMax, DimZMin:DimZMax), &
      & xz_DensCloudCond(DimXMin:DimXMax, DimZMin:DimZMax), &
      & xz_DensCloudFill(DimXMin:DimXMax, DimZMin:DimZMax)  &
      &  )

    call StoreDensCloudClean

  end subroutine StoreDensCloud_Init


  subroutine StoreDensCloudClean( )
    !ݴɤͤΥꥢ
    
    z_DensCloudAdv  = 0.0d0
    z_DensCloudTurb = 0.0d0
    z_DensCloudDiff = 0.0d0
    z_DensCloudCond = 0.0d0
    z_DensCloudFill = 0.0d0

    xz_DensCloudAdv  = 0.0d0
    xz_DensCloudTurb = 0.0d0
    xz_DensCloudDiff = 0.0d0
    xz_DensCloudCond = 0.0d0
    xz_DensCloudFill = 0.0d0
   
!    CalNum  = 1.0d-40    !ػ. 
  end subroutine StoreDensCloudClean


  subroutine StoreDensCloudMean()
    !ݴɤͤοʿʿ [K/s]
     real(8) :: CalNumShort

    CalNumShort = 2.0d0 * TimeDisp / DelTimeShort
    
    
    xz_DensCloudAdv  =  xz_DensCloudAdv    / CalNumShort
    xz_DensCloudTurb =  xz_DensCloudTurb   / CalNumShort
    xz_DensCloudDiff =  xz_DensCloudDiff   / CalNumShort
    xz_DensCloudCond =  xz_DensCloudCond   / CalNumShort
    xz_DensCloudFill =  xz_DensCloudFill   / CalNumShort

  end subroutine StoreDensCloudMean


  subroutine StoreDensCloudAdv( Work )
    !ήݴ

    implicit none

    real(8), intent(in)  :: Work(DimXMin:DimXMax, DimZMin:DimZMax)
    real(8)              :: Work2(DimXMin:DimXMax, DimZMin:DimZMax)

    Work2  = xz_DensCloudAdv + Work
    xz_DensCloudAdv = Work2

    write(*,*) "TendAdv", xz_DensCloudAdv(7,50)

  end subroutine StoreDensCloudAdv


  subroutine StoreDensCloudTurb( Work )
    !ήݴ

    implicit none

    real(8), intent(in)  :: Work(DimXMin:DimXMax, DimZMin:DimZMax)
    real(8)              :: Work2(DimXMin:DimXMax, DimZMin:DimZMax)

    Work2   = xz_DensCloudTurb + Work
    xz_DensCloudTurb = Work2

    write(*,*) "TendTurb", xz_DensCloudTurb(7,50)

  end subroutine StoreDensCloudTurb


  subroutine StoreDensCloudDiff( Work )
    !ͳȻݴ

    implicit none
    
    real(8), intent(in)  :: Work(DimXMin:DimXMax, DimZMin:DimZMax)
    real(8)              :: Work2(DimXMin:DimXMax, DimZMin:DimZMax)

    Work2   = xz_DensCloudDiff + Work
    xz_DensCloudDiff = Work2

    write(*,*) "TendDiff", xz_DensCloudDiff(7,50)

  end subroutine StoreDensCloudDiff

  subroutine StoreDensCloudCond( Work )
    !ǮȯǮݴ

    implicit none
    
    real(8), intent(in)  :: Work(DimXMin:DimXMax, DimZMin:DimZMax)
    real(8)              :: Work2(DimXMin:DimXMax, DimZMin:DimZMax)

    Work2   = xz_DensCloudCond + Work
    xz_DensCloudCond = Work2

    write(*,*) "TendCond", xz_DensCloudCond(7,50)
    write(*,*) "****"

  end subroutine StoreDensCloudCond

  subroutine StoreDensCloudFill( Work )
    !ץˤѲ

    implicit none

    real(8), intent(in)  :: Work(DimXMin:DimXMax, DimZMin:DimZMax)
    real(8)              :: Work2(DimXMin:DimXMax, DimZMin:DimZMax)

    Work2     = Work + xz_DensCloudFill
    xz_DensCloudFill = Work2

  end subroutine StoreDensCloudFill

  function a_MeanX_aa( var ) 
    !
    ! ʿʿͤη׻
    !
    
    !ۤηػ
    implicit none
    
    !ѿ
    real(8), intent(in)  :: var(DimXMin:DimXMax, DimZMin:DimZMax)
                                     !ʿѱ黻оݤȤʤѿ
    real(8)              :: a_MeanX_aa(DimZMin:DimZMax)
                                     !ʿʿ

    a_MeanX_aa = sum( var(RegXMin+1:RegXMax, :), 1 ) &
      &           / real(RegXMax - RegXMin, 8) 

  end function a_MeanX_aa
  

end module StoreDensCloud
